// 004 xxx
// 05 nov 2007

// -- Copyright (C) Felix John COLIBRI 2004 - All Rigths Reserved
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit a_mru_22_enter_user;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Drawing, System.Web, System.Web.SessionState,
  System.Web.UI, System.Web.UI.WebControls, System.Web.UI.HtmlControls,
  System.Web.Security, System.Web.UI.WebControls.WebParts, System.Configuration,
  Borland.Data.DataStore, Borland.Data.AdoDbxClientProvider;

type
  TDefault = class(System.Web.UI.Page)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
    procedure list_users__Click(sender: System.Object; e: System.EventArgs);
    procedure clear_display__Click(sender: System.Object; e: System.EventArgs);
    procedure enter_user__Click(sender: System.Object; e: System.EventArgs);
    procedure delete_users__Click(sender: System.Object; e: System.EventArgs);
    procedure generate_ids__Click(sender: System.Object; e: System.EventArgs);
    procedure list_separate__Click(sender: System.Object; e: System.EventArgs);
    procedure validate_user__Click(sender: System.Object; e: System.EventArgs);
    procedure all_users__Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
    DataStoreConnection1: Borland.Data.DataStore.DataStoreConnection;
    general_command_: Borland.Data.DataStore.DataStoreCommand;
    TextBox1: System.Web.UI.WebControls.TextBox;
    insert_users_command_: Borland.Data.DataStore.DataStoreCommand;
    user_id_textbox_: System.Web.UI.WebControls.TextBox;
    list_users_: System.Web.UI.WebControls.Button;
    user_name_textbox_: System.Web.UI.WebControls.TextBox;
    clear_display_: System.Web.UI.WebControls.Button;
    insert_membership_command_: Borland.Data.DataStore.DataStoreCommand;
    member_password_textbox_: System.Web.UI.WebControls.TextBox;
    member_password_format_textbox_: System.Web.UI.WebControls.TextBox;
    member_password_salt_textbox_: System.Web.UI.WebControls.TextBox;
    enter_user_: System.Web.UI.WebControls.Button;
    delete_users_: System.Web.UI.WebControls.Button;
    application_id_textbox_: System.Web.UI.WebControls.TextBox;
    insert_application_command_: Borland.Data.DataStore.DataStoreCommand;
    application_name_textbox_: System.Web.UI.WebControls.TextBox;
    generate_ids_: System.Web.UI.WebControls.Button;
    suffix_textbox_: System.Web.UI.WebControls.TextBox;
    list_separate_: System.Web.UI.WebControls.Button;
    check_user_name_textbox_: System.Web.UI.WebControls.TextBox;
    check_password_textbox_: System.Web.UI.WebControls.TextBox;
    validate_user_: System.Web.UI.WebControls.Button;
    validate_user_command_: Borland.Data.DataStore.DataStoreCommand;
    all_users_: System.Web.UI.WebControls.Button;
    test_application_command_: Borland.Data.DataStore.DataStoreCommand;
  protected
    procedure OnInit(e: EventArgs); override;
  private
    { Private Declarations }
  public
    procedure display(p_text: String);
    procedure clear_display;

    function f_exists_application(p_application_id: String): Boolean;
    procedure add_application;
    procedure add_user;
    procedure add_membership;

    function f_c_all_users(p_page_index, p_page_size: Integer): MembershipUserCollection;
  end;

implementation
  uses system.data.common // dbConnection
      // , Borland.Data.DataStore // params
   ;

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TDefault.InitializeComponent;
begin
  Self.DataStoreConnection1 := Borland.Data.DataStore.DataStoreConnection.Create;
  Self.general_command_ := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.insert_users_command_ := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.insert_membership_command_ := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.insert_application_command_ := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.validate_user_command_ := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.test_application_command_ := Borland.Data.DataStore.DataStoreCommand.Create;
  Include(Self.list_users_.Click, Self.list_users__Click);
  Include(Self.clear_display_.Click, Self.clear_display__Click);
  Include(Self.enter_user_.Click, Self.enter_user__Click);
  Include(Self.delete_users_.Click, Self.delete_users__Click);
  Include(Self.generate_ids_.Click, Self.generate_ids__Click);
  Include(Self.list_separate_.Click, Self.list_separate__Click);
  Include(Self.validate_user_.Click, Self.validate_user__Click);
  Include(Self.all_users_.Click, Self.all_users__Click);
  // 
  // DataStoreConnection1
  // 
  Self.DataStoreConnection1.ConnectionString := 'host=LocalHost;protocol=TCP' +
  ';database=C:\programs\us\web\asp_net\membership_roles_profile\_data\bfs_m' +
  'embership_manual.jds;user=SYSDBA;password=masterkey';
  // 
  // general_command_
  // 
  Self.general_command_.CommandText := nil;
  Self.general_command_.CommandTimeout := 0;
  Self.general_command_.Connection := Self.DataStoreConnection1;
  // 
  // insert_users_command_
  // 
  Self.insert_users_command_.CommandText := nil;
  Self.insert_users_command_.CommandTimeout := 0;
  Self.insert_users_command_.Connection := Self.DataStoreConnection1;
  Self.insert_users_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_users_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_users_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_users_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_users_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.Timestamp, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  // 
  // insert_membership_command_
  // 
  Self.insert_membership_command_.CommandText := nil;
  Self.insert_membership_command_.CommandTimeout := 0;
  Self.insert_membership_command_.Connection := Self.DataStoreConnection1;
  Self.insert_membership_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_membership_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_membership_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_membership_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.Int, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_membership_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_membership_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.Timestamp, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_membership_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.Timestamp, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_membership_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.Timestamp, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_membership_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.Timestamp, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_membership_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.Timestamp, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_membership_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.Timestamp, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  // 
  // insert_application_command_
  // 
  Self.insert_application_command_.CommandText := nil;
  Self.insert_application_command_.CommandTimeout := 0;
  Self.insert_application_command_.Connection := Self.DataStoreConnection1;
  Self.insert_application_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_application_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_application_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  // 
  // validate_user_command_
  // 
  Self.validate_user_command_.CommandText := nil;
  Self.validate_user_command_.CommandTimeout := 0;
  Self.validate_user_command_.Connection := Self.DataStoreConnection1;
  Self.validate_user_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  // 
  // test_application_command_
  // 
  Self.test_application_command_.CommandText := nil;
  Self.test_application_command_.CommandTimeout := 0;
  Self.test_application_command_.Connection := Self.DataStoreConnection1;
  Self.test_application_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Include(Self.Load, Self.Page_Load);
end;
{$ENDREGION}

    procedure TDefault.display(p_text: String);
      begin
        TextBox1.Text:= TextBox1.Text+ p_text+ chr(13)+ chr(10);
      end; // display

    procedure TDefault.clear_display;
      begin
        TextBox1.Text:= '';
      end; // clear_display

    procedure TDefault.OnInit(e: EventArgs);
      begin
        //
        // Required for Designer support
        //
        InitializeComponent;
        inherited OnInit(e);
      end; // OnInit

    procedure TDefault.Page_Load(sender: System.Object; e: System.EventArgs);
      begin
        // TODO: Put user code to initialize the page here
      end; // Page_Load

    procedure TDefault.clear_display__Click(sender: System.Object; e: System.EventArgs);
      begin
        clear_display;
      end; // clear_display__Click

    procedure execute_datastore_command(p_c_datastore_command: DataStoreCommand;
        p_request: String);
        // -- assumes the connection is open
      begin
        with p_c_datastore_command do
        begin
          CommandText:= p_request;
          ExecuteNonQuery;
        end; // with p_c_datastore_command
      end; // execute_datastore_command

    function f_list_datastore(p_c_datastore_command: DataStoreCommand;
        p_select_request: String): String;
        // -- assumes the connection is open
      var l_c_db_datareader: dbDataReader;
          l_column_index: Integer;
          l_row_display: String;
      begin
        with p_c_datastore_command do
        begin
          CommandText:= p_select_request;
          l_c_db_datareader:= ExecuteReader;

          Result:= '';

          while l_c_db_datareader.Read do
          begin
            l_row_display:= '';
            for l_column_index:= 0 to l_c_db_datareader.FieldCount- 1 do
              l_row_display:= l_row_display+ l_c_db_datareader.GetString(l_column_index)+ ' ';
            Result:= Result+ l_row_display+ '<BR>';
          end; // while l_c_db_datareader.Read

          l_c_db_datareader.Close;
        end; // with p_c_datastore_command
      end; // f_list_datastore

    procedure TDefault.generate_ids__Click(sender: System.Object; e: System.EventArgs);
      var l_suffix: Integer;
          l_string_suffix: String;
      begin
        l_suffix:= Convert.ToInt32(suffix_textbox_.Text);
        l_string_suffix:= l_suffix.ToString;

        // application_name_textbox_.Text:= 'app_'+ l_string_suffix;
        // application_id_textbox_.Text:= '100_'+ l_string_suffix;
        user_id_textbox_.Text:= '200_'+ l_string_suffix;
        user_name_textbox_.Text:= 'user_'+ l_string_suffix;
        member_password_textbox_.Text:= 'pass_'+ l_string_suffix;

        l_suffix:= l_suffix+ 1;
        suffix_textbox_.Text:= l_suffix.ToString;
      end; // generate_ids__Click

    // -- applications

    const k_add_application_request=
              'INSERT INTO aspnet_applications'
            + '   (applicationname, loweredapplicationname,'
            + '     applicationid'
            + '   ) '
            + '  VALUES (?, ?, ?)'
            ;
          k_exists_application_request=
              'SELECT applicationid'
            + '  FROM aspnet_applications'
            + '  WHERE applicationid= ?';

    function TDefault.f_exists_application(p_application_id: String): Boolean;
      var l_c_db_datareader: dbDataReader;
      begin
        display('> f_exists_application');
        DataStoreConnection1.Open;

        test_application_command_.CommandText:= k_exists_application_request;
        test_application_command_.Parameters[0].Value:= p_application_id;
        l_c_db_datareader:= test_application_command_.ExecuteReader;
        Result:= l_c_db_datareader.Read;

        l_c_db_datareader.Close;

        DataStoreConnection1.Close;
        display('< f_exists_application');
      end; // f_exists_application

    procedure TDefault.add_application;
      var l_request: String;
      begin
        display('> add_application');
        display(k_add_application_request);

        DataStoreConnection1.Open;
        l_request:= k_add_application_request;
        display(l_request);

        insert_application_command_.CommandText:= l_request;
        insert_application_command_.Prepare;

        insert_application_command_.Parameters[0].Value:= application_name_textbox_.Text;
        insert_application_command_.Parameters[1].Value:= application_name_textbox_.Text;
        insert_application_command_.Parameters[2].Value:= application_id_textbox_.Text;

        insert_application_command_.ExecuteNonQuery;

        DataStoreConnection1.Close;

        display('< add_application');
      end; // add_application

    // -- users

    const k_add_user_request=
              'INSERT INTO aspnet_users'
            + '  (applicationid, userid, username, loweredusername, '
            + '      isanonymous, lastactivitydata)'
            + '  VALUES (?, ?, ?, ?, False, ? )'
            ;

    procedure TDefault.add_user;
      var l_request: String;
      begin
        display('> add_user');
        // display(k_add_user_request);

        DataStoreConnection1.Open;
        l_request:= k_add_user_request;
        display(l_request);

        insert_users_command_.CommandText:= l_request;
        insert_users_command_.Prepare;

        insert_users_command_.Parameters[0].Value:= application_id_textbox_.Text;
        insert_users_command_.Parameters[1].Value:= user_id_textbox_.Text;
        insert_users_command_.Parameters[2].Value:= user_name_textbox_.Text;
        insert_users_command_.Parameters[3].Value:= user_name_textbox_.Text;
        insert_users_command_.Parameters[4].Value:= DateTime.Now;

        insert_users_command_.ExecuteNonQuery;

        DataStoreConnection1.Close;

        display('< add_user');
      end; // add_user

    // -- members

    const k_add_membership_request=
              'INSERT INTO aspnet_membership'
            + '  (applicationid, userid,'
            + '     password, passwordformat, passwordsalt'
(*
            + '     mobilepin, email, loweredemail,
            + '     passwordquestion, passwordanswer,
*)
            + '     , isapproved, islockedout'
            + '     , createdate, lastlogindate, lastpasswordchangeddate, lastlockoutdate'
            + '     , failedpasswordattemptcount, failedpasswordattemptwindowstart'
            + '     , failedpasswordanswerattemptcount, failedpasswordanswerattemptwindowstart'
            // + '     comment BLOB SUB_TYPE TEXT SEGMENT SIZE 80'
            + '    )'

            + '  VALUES '
            + '    ('
            + '       ?, ?, '
            + '       ?, ?, ? '
            + '       , True, False'
            + '       , ?, ?, ?, ? '
            + '       , 0, ?'
            + '       , 0, ?'
            + '    )';

    procedure TDefault.add_membership;
      var l_request: String;
      begin
        display('> add_member');

        DataStoreConnection1.Open;
        l_request:= k_add_membership_request;
        display(l_request);

        insert_membership_command_.CommandText:= l_request;
        insert_membership_command_.Prepare;

        insert_membership_command_.Parameters[0].Value:= application_id_textbox_.Text;
        insert_membership_command_.Parameters[1].Value:= user_id_textbox_.Text;
        insert_membership_command_.Parameters[2].Value:= member_password_textbox_.Text;
        insert_membership_command_.Parameters[3].Value:= member_password_format_textbox_.Text;
        insert_membership_command_.Parameters[4].Value:= member_password_salt_textbox_.Text;

        insert_membership_command_.Parameters[5].Value:= DateTime.Now;
        insert_membership_command_.Parameters[6].Value:= DateTime.Now;
        insert_membership_command_.Parameters[7].Value:= DateTime.Now;
        insert_membership_command_.Parameters[8].Value:= DateTime.Now;

        insert_membership_command_.Parameters[9].Value:= DateTime.Now;
        insert_membership_command_.Parameters[10].Value:= DateTime.Now;

        insert_membership_command_.ExecuteNonQuery;

        DataStoreConnection1.Close;

        display('< add_member');
      end; // add_membership

    procedure TDefault.enter_user__Click(sender: System.Object; e: System.EventArgs);
      begin
        display('> enter_user');
        DataStoreConnection1.Open;

        if not f_exists_application(application_id_textbox_.Text)
          then add_application
          else display('applications_exists');
        add_user;
        add_membership;

        DataStoreConnection1.Close;
        display('< enter_user');
      end; // enter_user__Click

    procedure TDefault.delete_users__Click(sender: System.Object; e: System.EventArgs);
      begin
        display('> delete_users');
        DataStoreConnection1.Open;

        execute_datastore_command(general_command_, 'DELETE FROM aspnet_applications');
        execute_datastore_command(general_command_, 'DELETE FROM aspnet_users');
        execute_datastore_command(general_command_, 'DELETE FROM aspnet_membership');

        DataStoreConnection1.Close;
        display('< delete_users');
      end; // delete_users__Click

    const k_list_users_request =

          'SELECT a.applicationname, a.applicationid, '
        + '      u.userid, u.username, m.password'
        + '  FROM aspnet_applications a, aspnet_users u, aspnet_membership m'
        + '  WHERE (a.applicationid= u.applicationid)'
        + '    AND (u.userid= m.userid)';
(*
          'SELECT u.userid'
        + '  FROM aspnet_users u'
        // + '  WHERE u.userid= m.userid'
        ;
*)

    procedure TDefault.list_separate__Click(sender: System.Object; e: System.EventArgs);
      begin
        display('> list_separate');
        DataStoreConnection1.Open;

        display(f_list_datastore(general_command_, 'SELECT * FROM aspnet_applications'));
        display(f_list_datastore(general_command_, 'SELECT * FROM aspnet_users'));
        display(f_list_datastore(general_command_, 'SELECT * FROM aspnet_membership'));

        DataStoreConnection1.Close;
        display('< list_separate');
      end; // list_separate__Click

    procedure TDefault.list_users__Click(sender: System.Object; e: System.EventArgs);
      var l_c_db_datareader: dbDataReader;
          l_column_index: Integer;
          l_row_display: String;
      begin
        display('> list_all_users');
        DataStoreConnection1.Open;
        general_command_.CommandText:= k_list_users_request;
        l_c_db_datareader:= general_command_.ExecuteReader;

        while l_c_db_datareader.Read do
        begin
          // display(l_c_db_datareader.GetString(0)); // + ' '+ l_c_db_reader.GetString(1));;
          l_row_display:= '';
          for l_column_index:= 0 to l_c_db_datareader.FieldCount- 1 do
            l_row_display:= l_row_display+ l_c_db_datareader.GetString(l_column_index)+ ' ';
          display(l_row_display);
        end; // while l_c_db_datareader.Read

        DataStoreConnection1.Close;
        display('< list_all_users');
      end; // list_users__Click

    // -- check how to use this database

    const k_select_password_hard_request=
              'SELECT m.password, m.isapproved'  // m.islockedout
            + '  FROM aspnet_users u, aspnet_membership m'
            + '  WHERE (u.username= ''user_4'') AND (u.userid= m.userid)';

    const k_select_password_request=
              'SELECT m.password ' // , m.isapproved, u.userid, m.userid, u.username'  // m.islockedout
            + '  FROM aspnet_users u, aspnet_membership m'
            + '  WHERE (u.username= ?) AND (u.userid= m.userid)';

          k_connection_string= 'host=LocalHost;protocol=TCP'
              + ';database=C:\programs\us\web\asp_net\membership_roles_profile\02_membership\21_membership_admin\my_data_manual\bfs_membership_manual.jds'
              + ';user=SYSDBA;password=masterkey';
(*
          'SELECT a.applicationname, a.applicationid, '
        + '      u.userid, u.username, m.password'
        + '  FROM aspnet_applications a, aspnet_users u, aspnet_membership m'
        + '  WHERE (a.applicationid= u.applicationid)'
        + '    AND (u.userid= m.userid)';
*)
    procedure TDefault.validate_user__Click(sender: System.Object; e: System.EventArgs);
(*
      var l_c_datastore_parameter: DataStoreParameter;
*)
      procedure validate_user_hard;
        var l_c_db_datareader: dbDataReader;
            l_database_password: String;
        begin
          general_command_.CommandText:= k_select_password_hard_request;
          l_c_db_datareader:= general_command_.ExecuteReader; // (CommandBehavior.SingleRow);

          if l_c_db_datareader= Nil
            then begin
                display('dbreader nil');
                Exit;
              end;

          l_c_db_datareader:= general_command_.ExecuteReader; // (CommandBehavior.SingleRow);

          l_c_db_datareader.Read;
          l_database_password:= l_c_db_datareader.GetString(0);
          display('dataase_pass '+ l_database_password);
          if check_password_textbox_.Text= l_database_password
            then display(' ok')
            else display(' NOT ok');
        end; // validate_user_hard

      procedure validate_user_specific_command;
        var l_c_db_datareader: dbDataReader;
            l_database_password: String;
        begin
          display(k_select_password_request);

          // -- object ref nil
          validate_user_command_.Prepare;

          validate_user_command_.Parameters[0].Value:= check_user_name_textbox_.Text;

          l_c_db_datareader:= validate_user_command_.ExecuteReader; // (CommandBehavior.SingleRow);

          l_c_db_datareader.Read;
          l_database_password:= l_c_db_datareader.GetString(0);
          display('dataase_pass '+ l_database_password);
          if check_password_textbox_.Text= l_database_password
            then display(' ok')
            else display(' NOT ok');
        end; // validate_user_specific_command

      procedure validate_create_command;
        var l_c_db_connection: DbConnection;
            l_c_db_command: DbCommand;
            l_c_datastore_parameter: DataStoreParameter;
            l_c_db_datareader: dbDataReader;
            l_c_db_parameter: dbParameter;
            l_database_password: String;
        begin
          l_c_db_connection:= Borland.Data.DataStore.DataStoreConnection.Create;
          l_c_db_connection.ConnectionString:= k_connection_string;
          l_c_db_connection.Open;

          // l_c_db_command:= DataStoreConnection.Create(k_select_password_request, DataStoreConnection1);
          l_c_db_command:= DataStoreCommand.Create;
          l_c_db_command.Connection:= l_c_db_connection;
          l_c_db_command.CommandText:= k_select_password_request;

          l_c_datastore_parameter:= DataStoreParameter.Create('user_param',
              Borland.Data.DataStore.DataStoreType.VarChar);
          l_c_datastore_parameter.Value:= check_user_name_textbox_.Text;
          l_c_db_command.Parameters.Add(l_c_datastore_parameter);

          l_c_db_command.Prepare;

          // l_c_db_parameter:= general_command_.Parameters.Add('@Username', DbType.String, 255);
          // general_command_.Parameters.Add(l_c_db_parameter);

          l_c_db_datareader:= l_c_db_command.ExecuteReader; // (CommandBehavior.SingleRow);

          if l_c_db_datareader= Nil
            then begin
                display('dbreader nil');
                Exit;
              end;

          l_c_db_datareader.Read;
          l_database_password:= l_c_db_datareader.GetString(0);
          display('dataase_pass '+ l_database_password);
          if check_password_textbox_.Text= l_database_password
            then display(' ok')
            else display(' NOT ok');
          l_c_db_connection.Close;
        end; // validate_create_command

      begin // validate_user__Click
        display('> validate_user');

        DataStoreConnection1.Open;

(*
        validate_user_hard;
        validate_user_specific_command;
*)
        validate_create_command;

(*
        general_command_.CommandText:= k_select_password_request;
        general_command_.Parameters.Clear;

        // -- no Create
        // -- l_c_db_parameter:= DbParameter.Create('user_param', DbType.String, 255);
        // l_c_db_parameter.Value:= check_user_name_textbox_.Text;
        l_c_datastore_parameter:= DataStoreParameter.Create('user_param',
            Borland.Data.DataStore.DataStoreType.VarChar);
        l_c_datastore_parameter.Value:= check_user_name_textbox_.Text;
        general_command_.Parameters.Add(l_c_datastore_parameter);

        general_command_.Prepare;

        // l_c_db_parameter:= general_command_.Parameters.Add('@Username', DbType.String, 255);
        // general_command_.Parameters.Add(l_c_db_parameter);

        l_c_db_datareader:= general_command_.ExecuteReader; // (CommandBehavior.SingleRow);

        if l_c_db_datareader= Nil
          then begin
              display('dbreader nil');
              Exit;
            end;

        l_c_db_datareader.Read;
        l_database_password:= l_c_db_datareader.GetString(0);
        display('dataase_pass '+ l_database_password);
        if check_password_textbox_.Text= l_database_password
          then display(' ok')
          else display(' NOT ok');

        general_command_.Parameters.Clear;
*)
        DataStoreConnection1.Close;
        display('< validate_user');
      end; // validate_user__Click

    // -- all users

    const // -- used by f_c_user_from_reader and GetAllUsers
          k_select_all_users_request=
              'SELECT u.userid, u.username, '
            + '    p.password, p.PasswordQuestion'
            + '  FROM aspnet_users u, aspnet_membership p'
            + '  WHERE u.userid= p.userid'
            + '  ORDER BY u.username ASC';

    function f_c_user_from_reader(p_c_db_datareader: dbDataReader): MembershipUser;
(*
      var lastLockedOutDate: DateTime;
          lastPasswordChangedDate: DateTime;
          lastActivityDate: DateTime;
          lastLoginDate: DateTime;
          creationDate: DateTime;

          isLockedOut: Boolean;
          isApproved: Boolean;
          comment: string;
          passwordQuestion: string;
          email: string;
          username: string;
          providerUserKey: System.Object;  ds: GUID !!
*)
      var l_user_name: String;
          l_password_question: String;
      begin
(*
        providerUserKey:= reader.GetValue(0);
        username:= reader.GetString(1);
        email:= reader.GetString(2);
        passwordQuestion:= '';
        if (reader.GetValue(3)<> DBNull.Value)
          then passwordQuestion:= reader.GetString(3);
        comment:= '';
        if (reader.GetValue(4)<> DBNull.Value)
          then comment:= reader.GetString(4);
        isApproved:= reader.GetBoolean(5);
        isLockedOut:= reader.GetBoolean(6);
        creationDate:= reader.GetDateTime(7);
        lastLoginDate:= DateTime.Create;
        if (reader.GetValue(8)<> DBNull.Value)
          then lastLoginDate:= reader.GetDateTime(8);
        lastActivityDate:= reader.GetDateTime(9);
        lastPasswordChangedDate:= reader.GetDateTime(10);
        lastLockedOutDate:= DateTime.Create;
        if (reader.GetValue(11)<> DBNull.Value)
          then lastLockedOutDate:= reader.GetDateTime(11);

        Result:= MembershipUser.Create(Name,
            username, providerUserKey, email,
            passwordQuestion, comment, isApproved, isLockedOut, creationDate,
            lastLoginDate, lastActivityDate, lastPasswordChangedDate,
            lastLockedOutDate);
*)
(*
        // -- NO: private default constructor !!!
        Result:= MembershipUser.Create;
        // -- CAUTION: this depends on the SELECT request
        with Result do
        begin
          UserName:= p_c_db_datareader.GetString(1);
          PasswordQuestion:= p_c_db_datareader.GetString(3);
        end;
*)
        l_user_name:= p_c_db_datareader.GetString(1);
        l_password_question:= p_c_db_datareader.GetString(3);

        Result:= MembershipUser.Create(
            // 'me',
            'AspNetAdoMembershipProvider',
            l_user_name, Nil, 'mail',
            l_password_question, '', True, False,
            DateTime.Now, DateTime.Now, DateTime.Now, DateTime.Now, DateTime.Now);
      end; // f_c_user_from_reader

    function tDefault.f_c_all_users(p_page_index, p_page_size: Integer): MembershipUserCollection;
      const k_count_users_request=
                'SELECT Count(*)'
              + '  FROM aspnet_users';
(*
                'SELECT PKID, Username, Email, PasswordQuestion,'+
                ' Comment, IsApproved, IsLockedOut, CreationDate, LastLoginDate'+
                ',')+
                ' LastActivityDate, LastPasswordChangedDate, LastLockedOutDate ')+
                ' FROM Users ')+ ' WHERE ApplicationName = ? ')+ ' ORDER BY User'+
                'name Asc');
*)
      var // l_c_membership_user_collection: MembershipUserCollection;

          l_c_db_connection: dbConnection;
          l_c_db_command: DbCommand;
          l_c_db_datareader: dbDataReader;

          l_user_count: Integer;
          l_start_index, l_end_index: Integer;
          l_current_count: Integer;

          l_c_membership_user: MembershipUser;

          // p_page_index, p_page_size: Integer;
      begin
        Result:= MembershipUserCollection.Create;
        // p_page_index:= 0; p_page_size:= 3;

        l_c_db_connection:= Borland.Data.DataStore.DataStoreConnection.Create;
        l_c_db_connection.ConnectionString:= k_connection_string; // m_connection_string;
        l_c_db_connection.Open;

        l_c_db_command:= DataStoreCommand.Create;
        l_c_db_command.Connection:= l_c_db_connection;
        l_c_db_command.CommandText:= k_count_users_request;

        // Nok l_user_count:= Integer(l_c_db_command.ExecuteScalar);
        // ok display(l_c_db_command.ExecuteScalar.ToString);
        l_user_count:= Convert.ToInt32(l_c_db_command.ExecuteScalar); // .ToInt32;
        // display(l_user_count.ToString);

        if l_user_count<= 0
          then Exit;

        l_c_db_command.CommandText:= k_select_all_users_request;

        l_c_db_datareader:= l_c_db_command.ExecuteReader;

        l_current_count:= 0;
        l_start_index:= p_page_index* p_page_size;
        l_end_index:= l_start_index+ p_page_size- 1;

        while l_c_db_datareader.Read do
        begin
          if l_current_count>= l_start_index
            then begin
                l_c_membership_user:= f_c_user_from_reader(l_c_db_datareader);
                // Result.Add(l_c_membership_user);
                Result.Add(l_c_membership_user);
              end;
          if l_current_count>= l_end_index
            then begin

                // "Method not supported" l_c_db_command.Cancel;
                Break;
              end;
          Inc(l_current_count);
        end; // while l_c_db_datareader.Read

        l_c_db_connection.Close;
      end; // all_users__Click

    procedure TDefault.all_users__Click(sender: System.Object; e: System.EventArgs);
      var l_c_membership_user_collection: MemberShipUserCollection;
          l_user_index: Integer;
          l_i_user_enumerator: iEnumerator;
      begin
        l_c_membership_user_collection:= // MemberShip.GetAllUsers();
            f_c_all_users(0, 3);
(*
        for l_user_index:= 0 to l_c_membership_user_collection.Count- 1 do
          with l_c_membership_user_collection.Item[l_user_index] do
            display(UserName, PasswordQuestion);
*)
        display('count '+ l_c_membership_user_collection.Count.ToString);

        l_i_user_enumerator:= l_c_membership_user_collection.GetEnumerator;
        while l_i_user_enumerator.MoveNext do
          with l_i_user_enumerator.Current as MembershipUser do
            display(UserName+ ' '+ PasswordQuestion);

      end; // all_users__Click

 end.

